package org.eclipse.osgi.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.lang.reflect.Field;
import java.util.Map;
import java.util.Properties;
import org.eclipse.osgi.util.NLS;

class MessagesProperties extends Properties {
  private static final int MOD_EXPECTED = 9;
  
  private static final int MOD_MASK = 25;
  
  private static final long serialVersionUID = 1L;
  
  private final String bundleName;
  
  private final Map fields;
  
  private final boolean isAccessible;
  
  public MessagesProperties(Map fieldMap, String bundleName, boolean isAccessible) {
    this.fields = fieldMap;
    this.bundleName = bundleName;
    this.isAccessible = isAccessible;
  }
  
  public synchronized Object put(Object key, Object value) {
    Object fieldObject = this.fields.put(key, NLS.ASSIGNED);
    if (fieldObject == NLS.ASSIGNED)
      return null; 
    if (fieldObject == null) {
      String msg = "NLS unused message: " + key + " in: " + this.bundleName;
      NLS.log(2, msg, null);
      return null;
    } 
    Field field = (Field)fieldObject;
    if ((field.getModifiers() & 0x19) != 9)
      return null; 
    try {
      if (!this.isAccessible)
        field.setAccessible(true); 
      field.set(null, value);
    } catch (Exception e) {
      NLS.log(4, "Exception setting field value.", e);
    } 
    return null;
  }
}
